﻿using ArcGIS.Core.CIM;
using ArcGIS.Core.Data;
using ArcGIS.Core.Data.UtilityNetwork;
using ArcGIS.Core.Geometry;
using ArcGIS.Desktop.Catalog;
using ArcGIS.Desktop.Core;
using ArcGIS.Desktop.Editing;
using ArcGIS.Desktop.Extensions;
using ArcGIS.Desktop.Framework;
using ArcGIS.Desktop.Framework.Contracts;
using ArcGIS.Desktop.Framework.Dialogs;
using ArcGIS.Desktop.Framework.Threading.Tasks;
using ArcGIS.Desktop.Layouts;
using ArcGIS.Desktop.Mapping;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DiscoveredSubnetworkDemo
{
  internal class ShowDiscoveredNetwork : Button
  {
    protected override void OnClick()
    {
      QueuedTask.Run(() =>
      {

       // Get UN layer from TOC
       IReadOnlyList<Layer> tocLayers = MapView.Active.Map.GetLayersAsFlattenedList();
        if (tocLayers.Count > 0)
        {
          foreach (Layer layer in tocLayers)
          {
            if (layer is UtilityNetworkLayer utilityNetworkLayer)
            {
              using (UtilityNetwork utilityNetwork = utilityNetworkLayer.GetUtilityNetwork())
              using (Geodatabase geodatabase = utilityNetwork.GetDatastore() as Geodatabase)
              {
                ValidationResult validationResult = utilityNetwork.ValidateNetworkTopologyInEditOperation(null, ServiceSynchronizationType.Synchronous);

                bool isDiscoveredSubnetworkSupported = validationResult.IsDiscoveredSubnetworksSupported;
                if (!isDiscoveredSubnetworkSupported)
                {
                 // Server version prior to 11.1 
                }
                else
                {
                  IReadOnlyList<Subnetwork> subnetworks = validationResult.GetDiscoveredSubnetworks();
                }
             }
            }
          }
        }
        else
        {
          MessageBox.Show("Add layers in the map");
        }



      });

    }
  }
}
