**Geodatabase Versioning Sample Code**

This repo contains a sample add-in for partial posting in geodatabase branch versioning. This tool is upgraded to  support .Net6 and VS 2022 for Pro SDK 3.1.

Publish your branch versioned FSDB prior to using this addin. Reference dataset location in file geodatabase format: \\\esri.com\Departments\Development\Geodatabase\Users\alamsal\GrandTeton.gdb.
[Refer to share branch versioned data](https://pro.arcgis.com/en/pro-app/latest/help/data/geodatabases/overview/publish-branch-versioned-data.htm)

The core code of the versioning operation lies in [VersionOperationsService.cs](https://devtopia.esri.com/aas11333/DevSummit_VersioningDemo/blob/master/VersionOperationsService.cs)  

**Steps to run:**
1. Clone the repo and build the sample add-in VS 2022/.Net 6 or **Step 2**

1. Install the **VersionManagement.esriAddinX** add-in from **\\\esri.com\Departments\Development\Geodatabase\Users\alamsal\VersionManagementEsriAddin**

1. Add the FSDB layers from Portal to TOC (without group layer)
![image](./Doc_Images/PortalToTOC.PNG)

1. Open **Add-in** and Click **Show VersioOperationDockPane** button to open partial posting and version management dock pane
![image](./Doc_Images/OpenAddin.PNG)
![image](./Doc_Images/PP_Versioning_DocPane.PNG)

1. Remove older versions via Pro UI (not necessary but the add-in doesn't show them)
![image](./Doc_Images/ManageVersions.PNG)

1. Create a version using add-in

1. Switch to a version using select button
![image](./Doc_Images/CreateVersion.png)
1. Create features

1. Hit **Post** button to post all changes to the default

1. Select features to **Partial Post**, next hit **Add Selected** for bookkeeping, and then hit **Post** button
![image](./Doc_Images/PP1.png)
![image](./Doc_Images/PP2.png)
![image](./Doc_Images/PP3.png)
1. Switch to default to view changes
![image](./Doc_Images/DefaultAfterPP.png)
1. Reconcile to reconcile the changes from default
1. Deleted records are stored in a custom table using attribute rule to track the OID of deleted features
![image](./Doc_Images/AttributeRule.png)

The feature services used in the demo are published in ArcGIS Server 11.0 using SQL Server SDE connection.

This repo was demoed on ESRI Dev Summit 2020 and 2021 on **Versioning Variations: An In-Depth Look at Using ArcGIS Pro SDK with Geodatabase Versioning** session.
